# swagger-client
qTest Manager API Version 11.0.0 - 2023.6

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 11.0.0 - 2023.6
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: Authorization
configuration = swagger_client.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.AttachmentApi(swagger_client.ApiClient(configuration))
project_id = 789 # int | ID of the project
blob_handle_id = 789 # int | ID of the Attachment
object_type = 'object_type_example' # str | Valid values include releases, builds, requirements, test-cases, test-logs, test-steps, test-step-logs or defects  <strong>qTest Manager version:</strong> 4+
object_id = 789 # int | ID of the object (Release, Build, Requirement, Test Case, Test Log, Test Step, Test Step Log or Defect)

try:
    # Deletes an Attachment from an Object
    api_response = api_instance.delete_by_blob_handle_id(project_id, blob_handle_id, object_type, object_id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AttachmentApi->delete_by_blob_handle_id: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://apitryout.qtestnet.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AttachmentApi* | [**delete_by_blob_handle_id**](docs/AttachmentApi.md#delete_by_blob_handle_id) | **DELETE** /api/v3/projects/{projectId}/{objectType}/{objectId}/blob-handles/{blobHandleId} | Deletes an Attachment from an Object
*AttachmentApi* | [**get_attachment**](docs/AttachmentApi.md#get_attachment) | **GET** /api/v3/projects/{projectId}/{objectType}/{objectId}/attachments/{attachmentId} | Gets an Attachment of an Object
*AttachmentApi* | [**get_attachments_of**](docs/AttachmentApi.md#get_attachments_of) | **GET** /api/v3/projects/{projectId}/{objectType}/{objectId}/attachments | Gets all Attachments of an Object
*AttachmentApi* | [**search**](docs/AttachmentApi.md#search) | **GET** /api/v3/projects/{projectId}/attachments | Searches for Attachments
*AttachmentApi* | [**upload**](docs/AttachmentApi.md#upload) | **POST** /api/v3/projects/{projectId}/{objectType}/{objectId}/blob-handles | Uploads an Attachment to an Object
*AuthSystemsApi* | [**get_all**](docs/AuthSystemsApi.md#get_all) | **GET** /api/v3/auth-systems | Get multiple Authentication Systems
*AuthSystemsApi* | [**get_all_ldap_users**](docs/AuthSystemsApi.md#get_all_ldap_users) | **GET** /api/v3/auth-systems/ldap/{ldapAuthConfigId}/users | Get all LDAP users of an authentication LDAP config
*AuthSystemsApi* | [**import_l_dap_users**](docs/AuthSystemsApi.md#import_l_dap_users) | **POST** /api/v3/auth-systems/ldap/{ldapAuthConfigId}/import | Associate Manager users with LDAP users
*AutomationJobApi* | [**create_schedule**](docs/AutomationJobApi.md#create_schedule) | **POST** /api/v3/automation/jobs/schedule/create | Create a Schedule
*AutomationJobApi* | [**search_automation_agents**](docs/AutomationJobApi.md#search_automation_agents) | **POST** /api/v3/automation/automation-agents | Search automation agents
*BuildApi* | [**create**](docs/BuildApi.md#create) | **POST** /api/v3/projects/{projectId}/builds | Creates a Build
*BuildApi* | [**delete**](docs/BuildApi.md#delete) | **DELETE** /api/v3/projects/{projectId}/builds/{buildId} | Deletes a Build
*BuildApi* | [**get**](docs/BuildApi.md#get) | **GET** /api/v3/projects/{projectId}/builds/{buildId} | Gets a Build
*BuildApi* | [**get_builds**](docs/BuildApi.md#get_builds) | **GET** /api/v3/projects/{projectId}/builds | Gets multiple Builds
*BuildApi* | [**update**](docs/BuildApi.md#update) | **PUT** /api/v3/projects/{projectId}/builds/{buildId} | Updates a Build
*CommonApi* | [**edit_system_field**](docs/CommonApi.md#edit_system_field) | **POST** /api/v3/projects/{projectId}/settings/{objectType}/system-fields/{fieldId} | Edit System Field of an Object Type by the field
*CommonApi* | [**update_custom_field_status**](docs/CommonApi.md#update_custom_field_status) | **POST** /api/v3/projects/{projectId}/settings/{objectType}/custom-fields/active | Update active or inactive custom fields of an Object Type
*DefectApi* | [**add_comment**](docs/DefectApi.md#add_comment) | **POST** /api/v3/projects/{projectId}/defects/{idOrKey}/comments | Adds a Comment to a Defect
*DefectApi* | [**delete_comment**](docs/DefectApi.md#delete_comment) | **DELETE** /api/v3/projects/{projectId}/defects/{idOrKey}/comments/{commentId} | Deletes a Comment of a Defect
*DefectApi* | [**get_comments**](docs/DefectApi.md#get_comments) | **GET** /api/v3/projects/{projectId}/defects/{idOrKey}/comments | Gets all Comments of a Defect
*DefectApi* | [**get_defect**](docs/DefectApi.md#get_defect) | **GET** /api/v3/projects/{projectId}/defects/{defectId} | Gets a Defect
*DefectApi* | [**get_defect_comment_by_id**](docs/DefectApi.md#get_defect_comment_by_id) | **GET** /api/v3/projects/{projectId}/defects/{idOrKey}/comments/{commentId} | Gets a Comment of a Defect
*DefectApi* | [**get_last_changed**](docs/DefectApi.md#get_last_changed) | **GET** /api/v3/projects/{projectId}/defects/last-change | Gets recently updated Defects
*DefectApi* | [**submit_defect**](docs/DefectApi.md#submit_defect) | **POST** /api/v3/projects/{projectId}/defects | Submit a Defect
*DefectApi* | [**update_comment**](docs/DefectApi.md#update_comment) | **PUT** /api/v3/projects/{projectId}/defects/{idOrKey}/comments/{commentId} | Updates a Comment of a Defect
*DefectApi* | [**update_defect**](docs/DefectApi.md#update_defect) | **PUT** /api/v3/projects/{projectId}/defects/{defectId} | Updates a Defect
*FieldApi* | [**create_custom_field**](docs/FieldApi.md#create_custom_field) | **POST** /api/v3/projects/{projectId}/settings/{objectType}/fields | Creates a Custom Field of an Object Type
*FieldApi* | [**create_custom_site_field**](docs/FieldApi.md#create_custom_site_field) | **POST** /api/v3/fields/{objectType} | Creates a Custom Site Field of an Object Type
*FieldApi* | [**create_project_field_allowed_values**](docs/FieldApi.md#create_project_field_allowed_values) | **POST** /api/v3/projects/{projectId}/settings/{objectType}/fields/{fieldId}/allowed-values | Creates allowed values of a Project Field
*FieldApi* | [**create_site_field_allowed_values**](docs/FieldApi.md#create_site_field_allowed_values) | **POST** /api/v3/fields/{objectType}/{fieldId}/allowed-values | Creates allowed values of a Site Field
*FieldApi* | [**delete_custom_field**](docs/FieldApi.md#delete_custom_field) | **DELETE** /api/v3/projects/{projectId}/settings/{objectType}/fields/{fieldId} | Deletes a Custom Field of an Object Type
*FieldApi* | [**delete_custom_site_field**](docs/FieldApi.md#delete_custom_site_field) | **DELETE** /api/v3/fields/{objectType}/{fieldId} | Deletes a Custom Site Field of an Object Type
*FieldApi* | [**delete_project_field_value**](docs/FieldApi.md#delete_project_field_value) | **DELETE** /api/v3/projects/{projectId}/settings/{objectType}/fields/{fieldId}/allowed-values/{value} | Deletes an allowed value of a Project Field
*FieldApi* | [**delete_site_field_value**](docs/FieldApi.md#delete_site_field_value) | **DELETE** /api/v3/fields/{objectType}/{fieldId}/allowed-values/{value} | Deletes an allowed value of a Site Field
*FieldApi* | [**get_all_site_fields**](docs/FieldApi.md#get_all_site_fields) | **GET** /api/v3/fields/{objectType} | Gets all site field of an object type
*FieldApi* | [**get_custom_field**](docs/FieldApi.md#get_custom_field) | **GET** /api/v3/projects/{projectId}/settings/{objectType}/fields/{fieldId} | Gets a Custom Field of an Object Type
*FieldApi* | [**get_custom_site_field**](docs/FieldApi.md#get_custom_site_field) | **GET** /api/v3/fields/{objectType}/{fieldId} | Gets a Custom Site Field of an Object Type
*FieldApi* | [**get_fields**](docs/FieldApi.md#get_fields) | **GET** /api/v3/projects/{projectId}/settings/{objectType}/fields | Gets all Fields of an Object Type
*FieldApi* | [**get_project_field_allowed_values**](docs/FieldApi.md#get_project_field_allowed_values) | **GET** /api/v3/projects/{projectId}/settings/{objectType}/fields/{fieldId}/allowed-values | Gets all allowed values of a Project Field
*FieldApi* | [**get_site_field_allowed_values**](docs/FieldApi.md#get_site_field_allowed_values) | **GET** /api/v3/fields/{objectType}/{fieldId}/allowed-values | Gets all allowed values of a Site Field
*FieldApi* | [**update_custom_field**](docs/FieldApi.md#update_custom_field) | **PUT** /api/v3/projects/{projectId}/settings/{objectType}/fields/{fieldId} | Updates a Custom Field of an Object Type
*FieldApi* | [**update_custom_site_field**](docs/FieldApi.md#update_custom_site_field) | **PUT** /api/v3/fields/{objectType}/{fieldId} | Updates a Custom Site Field of an Object Type
*FieldApi* | [**update_project_field_allowed_values**](docs/FieldApi.md#update_project_field_allowed_values) | **PUT** /api/v3/projects/{projectId}/settings/{objectType}/fields/{fieldId}/allowed-values/{value} | Updates an allowed value of a Project Field
*FieldApi* | [**update_site_field_allowed_values**](docs/FieldApi.md#update_site_field_allowed_values) | **PUT** /api/v3/fields/{objectType}/{fieldId}/allowed-values/{value} | Updates an allowed value of a Site Field
*GroupsApi* | [**create_custom_user_group**](docs/GroupsApi.md#create_custom_user_group) | **POST** /api/v3/groups | Create custom UserGroup
*GroupsApi* | [**get_all_user_groups**](docs/GroupsApi.md#get_all_user_groups) | **GET** /api/v3/groups | Get multiple UserGroups
*IntegrationSettingsApi* | [**add_new_connection**](docs/IntegrationSettingsApi.md#add_new_connection) | **POST** /api/v3/projects/{projectId}/settings/integration/connections | Add a new Jira connection
*IntegrationSettingsApi* | [**add_new_defect_mapping**](docs/IntegrationSettingsApi.md#add_new_defect_mapping) | **POST** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/defect/mappings | Add a defect mapping to a Jira connection
*IntegrationSettingsApi* | [**add_new_release_mapping**](docs/IntegrationSettingsApi.md#add_new_release_mapping) | **POST** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/release/mappings | Add a new Jira release mapping to a Jira connection
*IntegrationSettingsApi* | [**add_new_requirement_mapping**](docs/IntegrationSettingsApi.md#add_new_requirement_mapping) | **POST** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/requirement/mappings | Add a requirement mapping to a Jira connection
*IntegrationSettingsApi* | [**configure_populating_jira_unlinked_defects**](docs/IntegrationSettingsApi.md#configure_populating_jira_unlinked_defects) | **PUT** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/defect | Enable or disable populating Jira Unlinked Defects of a Jira connection
*IntegrationSettingsApi* | [**configure_release_mapping**](docs/IntegrationSettingsApi.md#configure_release_mapping) | **PUT** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/release/mappings | Update a Release Mapping of a Jira connection
*IntegrationSettingsApi* | [**configure_requirement_mapping**](docs/IntegrationSettingsApi.md#configure_requirement_mapping) | **PUT** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/requirement/mappings | Update a requirement mapping of a Jira connection
*IntegrationSettingsApi* | [**delete_connection**](docs/IntegrationSettingsApi.md#delete_connection) | **DELETE** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId} | Delete a Jira connection
*IntegrationSettingsApi* | [**get_authorize_url**](docs/IntegrationSettingsApi.md#get_authorize_url) | **GET** /api/v3/projects/{projectId}/settings/integration/connections/oauthAuthorizeURL | OAuth Authorize URL
*IntegrationSettingsApi* | [**get_connections**](docs/IntegrationSettingsApi.md#get_connections) | **GET** /api/v3/projects/{projectId}/settings/integration/connections | Get all Jira connections of a project
*IntegrationSettingsApi* | [**get_defect_mappings**](docs/IntegrationSettingsApi.md#get_defect_mappings) | **GET** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/defect/mappings | Get Jira defect mappings of a Jira connection
*IntegrationSettingsApi* | [**get_release_mappings**](docs/IntegrationSettingsApi.md#get_release_mappings) | **GET** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/release/mappings | Get Jira release mappings of a Jira connection
*IntegrationSettingsApi* | [**refresh_field_settings**](docs/IntegrationSettingsApi.md#refresh_field_settings) | **POST** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/refreshFieldSettings | Trigger retrieving latest field settings from a JIRA connection
*IntegrationSettingsApi* | [**remove_mapping**](docs/IntegrationSettingsApi.md#remove_mapping) | **DELETE** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/{artifact}/mappings | Remove a Mapping of a Jira connection
*IntegrationSettingsApi* | [**retrieve_all_requirement_mappings_of_connection**](docs/IntegrationSettingsApi.md#retrieve_all_requirement_mappings_of_connection) | **GET** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/requirement/mappings | Get requirement mappings of a Jira connection
*IntegrationSettingsApi* | [**toggle_release_integration**](docs/IntegrationSettingsApi.md#toggle_release_integration) | **PUT** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/release | Enable or disable Release Integration feature of a Jira connection
*IntegrationSettingsApi* | [**toggle_requirement_integration**](docs/IntegrationSettingsApi.md#toggle_requirement_integration) | **PUT** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/requirement | Enable or disable a Requirement Integration feature of a Jira connection
*IntegrationSettingsApi* | [**trigger_retrieving_data_for_connection**](docs/IntegrationSettingsApi.md#trigger_retrieving_data_for_connection) | **GET** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/retrieve | Trigger data retrieval from an integrated Jira system
*IntegrationSettingsApi* | [**trigger_retrieving_defect_data_for_connection**](docs/IntegrationSettingsApi.md#trigger_retrieving_defect_data_for_connection) | **POST** /api/v3/projects/{projectId}/settings/jira-integration/defect/retrieve | Trigger defect retrieval from an integrated Jira system
*IntegrationSettingsApi* | [**update_defect_mapping**](docs/IntegrationSettingsApi.md#update_defect_mapping) | **PUT** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId}/defect/mappings | Update a defect mapping of Jira connection
*IntegrationSettingsApi* | [**update_integration_connection_status**](docs/IntegrationSettingsApi.md#update_integration_connection_status) | **PUT** /api/v3/projects/{projectId}/settings/integration/connections/{connectionId} | Activate or deactivate a Jira connection
*LoginApi* | [**post_access_token**](docs/LoginApi.md#post_access_token) | **POST** /oauth/token | Log in
*LoginApi* | [**token_status**](docs/LoginApi.md#token_status) | **GET** /oauth/status | Gets status of access token
*ModuleApi* | [**create_module**](docs/ModuleApi.md#create_module) | **POST** /api/v3/projects/{projectId}/modules | Creates a Module
*ModuleApi* | [**delete_module**](docs/ModuleApi.md#delete_module) | **DELETE** /api/v3/projects/{projectId}/modules/{moduleId} | Deletes a Module
*ModuleApi* | [**get_module**](docs/ModuleApi.md#get_module) | **GET** /api/v3/projects/{projectId}/modules/{moduleId} | Gets a Module
*ModuleApi* | [**get_sub_modules_of**](docs/ModuleApi.md#get_sub_modules_of) | **GET** /api/v3/projects/{projectId}/modules | Gets multiple Modules
*ModuleApi* | [**update_module**](docs/ModuleApi.md#update_module) | **PUT** /api/v3/projects/{projectId}/modules/{moduleId} | Updates a Module
*ObjectLinkApi* | [**find**](docs/ObjectLinkApi.md#find) | **GET** /api/v3/projects/{projectId}/linked-artifacts | Gets associated objects of given objects
*ObjectLinkApi* | [**link_artifacts**](docs/ObjectLinkApi.md#link_artifacts) | **POST** /api/v3/projects/{projectId}/{objectType}/{objectId}/link | Creates links between objects
*ObjectLinkApi* | [**link_artifacts_by_pid**](docs/ObjectLinkApi.md#link_artifacts_by_pid) | **POST** /api/v3/projects/{projectId}/{objectType}/{objectId}/{linkType} | Creates links between objects by pids
*ObjectLinkApi* | [**unlink_artifacts**](docs/ObjectLinkApi.md#unlink_artifacts) | **DELETE** /api/v3/projects/{projectId}/{objectType}/{objectId}/link | Removes links between objects
*ObjectLinkApi* | [**unlink_artifacts_by_pid**](docs/ObjectLinkApi.md#unlink_artifacts_by_pid) | **DELETE** /api/v3/projects/{projectId}/{objectType}/{objectId}/{linkType} | Removes links between objects by pids
*ProjectApi* | [**create_project**](docs/ProjectApi.md#create_project) | **POST** /api/v3/projects | Creates a Project
*ProjectApi* | [**get_current_profile**](docs/ProjectApi.md#get_current_profile) | **GET** /api/v3/projects/{projectId}/user-profiles/current | Gets current user Permissions in a Project
*ProjectApi* | [**get_project**](docs/ProjectApi.md#get_project) | **GET** /api/v3/projects/{projectId} | Gets a Project
*ProjectApi* | [**get_projects**](docs/ProjectApi.md#get_projects) | **GET** /api/v3/projects | Gets multiple Projects
*ProjectApi* | [**get_users**](docs/ProjectApi.md#get_users) | **GET** /api/v3/projects/{projectId}/users | Gets all Users in a Project
*ProjectApi* | [**search_projects**](docs/ProjectApi.md#search_projects) | **POST** /api/v3/projects/search | Search for projects
*ProjectApi* | [**update_project**](docs/ProjectApi.md#update_project) | **PUT** /api/v3/projects/{projectId} | Updates a Project
*ReleaseApi* | [**create_release**](docs/ReleaseApi.md#create_release) | **POST** /api/v3/projects/{projectId}/releases | Creates a Release
*ReleaseApi* | [**delete_release_by_id**](docs/ReleaseApi.md#delete_release_by_id) | **DELETE** /api/v3/projects/{projectId}/releases/{releaseId} | Delete a release
*ReleaseApi* | [**get_all_releases**](docs/ReleaseApi.md#get_all_releases) | **GET** /api/v3/projects/{projectId}/releases | Gets multiple Releases
*ReleaseApi* | [**get_release_by_id**](docs/ReleaseApi.md#get_release_by_id) | **GET** /api/v3/projects/{projectId}/releases/{releaseId} | Gets a Release
*ReleaseApi* | [**update_release_by_id**](docs/ReleaseApi.md#update_release_by_id) | **PUT** /api/v3/projects/{projectId}/releases/{releaseId} | Updates a Release
*RequirementApi* | [**add_requirement_comment**](docs/RequirementApi.md#add_requirement_comment) | **POST** /api/v3/projects/{projectId}/requirements/{idOrKey}/comments | Adds a Comment to a Requirement
*RequirementApi* | [**create_requirement**](docs/RequirementApi.md#create_requirement) | **POST** /api/v3/projects/{projectId}/requirements | Creates a Requirement
*RequirementApi* | [**delete_requirement_by_id**](docs/RequirementApi.md#delete_requirement_by_id) | **DELETE** /api/v3/projects/{projectId}/requirements/{requirementId} | Deletes a Requirement
*RequirementApi* | [**delete_requirement_comment_by_id**](docs/RequirementApi.md#delete_requirement_comment_by_id) | **DELETE** /api/v3/projects/{projectId}/requirements/{idOrKey}/comments/{commentId} | Deletes a Comment of a Requirement
*RequirementApi* | [**get_all_requirement_comments**](docs/RequirementApi.md#get_all_requirement_comments) | **GET** /api/v3/projects/{projectId}/requirements/{idOrKey}/comments | Gets all Comments of a Requirement
*RequirementApi* | [**get_public_traceability_matrix_report**](docs/RequirementApi.md#get_public_traceability_matrix_report) | **GET** /api/v3/projects/{projectId}/requirements/trace-matrix-report | Gets Requirement Traceability Matrix Report
*RequirementApi* | [**get_requirement**](docs/RequirementApi.md#get_requirement) | **GET** /api/v3/projects/{projectId}/requirements/{requirementId} | Gets a Requirement
*RequirementApi* | [**get_requirement_comment_by_id**](docs/RequirementApi.md#get_requirement_comment_by_id) | **GET** /api/v3/projects/{projectId}/requirements/{idOrKey}/comments/{commentId} | Gets a Comment of a Requirement
*RequirementApi* | [**get_requirements**](docs/RequirementApi.md#get_requirements) | **GET** /api/v3/projects/{projectId}/requirements | Gets multiple Requirements
*RequirementApi* | [**get_test_runs_by_requirment_id**](docs/RequirementApi.md#get_test_runs_by_requirment_id) | **GET** /api/v3/projects/{projectId}/requirements/{requirementId}/test-runs | To get all test runs associated to requirement
*RequirementApi* | [**update_requirement**](docs/RequirementApi.md#update_requirement) | **PUT** /api/v3/projects/{projectId}/requirements/{requirementId} | Updates a Requirement
*RequirementApi* | [**update_requirement_comment_by_id**](docs/RequirementApi.md#update_requirement_comment_by_id) | **PUT** /api/v3/projects/{projectId}/requirements/{idOrKey}/comments/{commentId} | Updates a Comment of a Requirement
*SearchApi* | [**query_histories**](docs/SearchApi.md#query_histories) | **POST** /api/v3/projects/{projectId}/histories | Queries objects&#39; histories
*SearchApi* | [**search_artifact**](docs/SearchApi.md#search_artifact) | **POST** /api/v3/projects/{projectId}/search | Queries objects
*SearchApi* | [**search_comment_with_query**](docs/SearchApi.md#search_comment_with_query) | **POST** /api/v3/projects/{projectId}/comments | Queries Comments
*SiteTemplatesApi* | [**add_projects**](docs/SiteTemplatesApi.md#add_projects) | **POST** /api/v3/site-templates/{templateId}/projects | Apply template to existing projects.
*SiteTemplatesApi* | [**get_all_site_templates**](docs/SiteTemplatesApi.md#get_all_site_templates) | **GET** /api/v3/site-templates | Get all site-templates
*SiteTemplatesApi* | [**remove_project_templates**](docs/SiteTemplatesApi.md#remove_project_templates) | **DELETE** /api/v3/site-templates/{templateId}/projects | Remove projects from a site template.
*TestCaseApi* | [**add_test_case_comment**](docs/TestCaseApi.md#add_test_case_comment) | **POST** /api/v3/projects/{projectId}/test-cases/{idOrKey}/comments | Adds a Comment to a Test Case
*TestCaseApi* | [**add_test_step**](docs/TestCaseApi.md#add_test_step) | **POST** /api/v3/projects/{projectId}/test-cases/{testCaseId}/test-steps | Creates a Test Step
*TestCaseApi* | [**approve_test_case**](docs/TestCaseApi.md#approve_test_case) | **PUT** /api/v3/projects/{projectId}/test-cases/{testCaseId}/approve | Approves a Test Case
*TestCaseApi* | [**approve_test_case_by_vera**](docs/TestCaseApi.md#approve_test_case_by_vera) | **PUT** /api/v3/projects/{projectId}/test-cases/{testCaseId}/vera/approve | test-case.vera.approve
*TestCaseApi* | [**create_test_case**](docs/TestCaseApi.md#create_test_case) | **POST** /api/v3/projects/{projectId}/test-cases | Creates a Test Case
*TestCaseApi* | [**delete_test_case**](docs/TestCaseApi.md#delete_test_case) | **DELETE** /api/v3/projects/{projectId}/test-cases/{testCaseId} | Deletes a Test Case
*TestCaseApi* | [**delete_test_case_comment**](docs/TestCaseApi.md#delete_test_case_comment) | **DELETE** /api/v3/projects/{projectId}/test-cases/{idOrKey}/comments/{commentId} | Deletes a Comment of a Test Case
*TestCaseApi* | [**delete_test_step**](docs/TestCaseApi.md#delete_test_step) | **DELETE** /api/v3/projects/{projectId}/test-cases/{testCaseId}/test-steps/{stepId} | Deletes a Test Step
*TestCaseApi* | [**get_test_case**](docs/TestCaseApi.md#get_test_case) | **GET** /api/v3/projects/{projectId}/test-cases/{testCaseIdOrPid} | Gets a Test Case
*TestCaseApi* | [**get_test_case_comment_by_id**](docs/TestCaseApi.md#get_test_case_comment_by_id) | **GET** /api/v3/projects/{projectId}/test-cases/{idOrKey}/comments/{commentId} | Gets a Comment of a Test Case
*TestCaseApi* | [**get_test_case_comments**](docs/TestCaseApi.md#get_test_case_comments) | **GET** /api/v3/projects/{projectId}/test-cases/{idOrKey}/comments | Gets all Comments of a Test Case
*TestCaseApi* | [**get_test_case_version_by_id**](docs/TestCaseApi.md#get_test_case_version_by_id) | **GET** /api/v3/projects/{projectId}/test-cases/{testCaseId}/versions/{versionId} | Gets a version of a Test Case
*TestCaseApi* | [**get_test_cases**](docs/TestCaseApi.md#get_test_cases) | **GET** /api/v3/projects/{projectId}/test-cases | Gets multiple Test Cases
*TestCaseApi* | [**get_test_step**](docs/TestCaseApi.md#get_test_step) | **GET** /api/v3/projects/{projectId}/test-cases/{testCaseId}/test-steps/{stepId} | Gets a Test Step
*TestCaseApi* | [**get_test_steps**](docs/TestCaseApi.md#get_test_steps) | **GET** /api/v3/projects/{projectId}/test-cases/{testCaseId}/test-steps | Gets Test Steps of a Test Case
*TestCaseApi* | [**get_test_steps_by_version**](docs/TestCaseApi.md#get_test_steps_by_version) | **GET** /api/v3/projects/{projectId}/test-cases/{testCaseId}/versions/{versionId}/test-steps | Gets Test Steps of a Test Case version
*TestCaseApi* | [**get_test_steps_by_version_id**](docs/TestCaseApi.md#get_test_steps_by_version_id) | **GET** /api/v4/projects/{projectId}/test-cases/{testCaseId}/versions/{versionId}/test-steps | Gets Test Steps of a Test Case version
*TestCaseApi* | [**get_test_steps_of_test_case**](docs/TestCaseApi.md#get_test_steps_of_test_case) | **GET** /api/v4/projects/{projectId}/test-cases/{testCaseId}/test-steps | Gets Test Steps of a Test Case
*TestCaseApi* | [**get_versions**](docs/TestCaseApi.md#get_versions) | **GET** /api/v3/projects/{projectId}/test-cases/{testCaseId}/versions | Gets all versions of a Test Case
*TestCaseApi* | [**update_multiple_test_cases**](docs/TestCaseApi.md#update_multiple_test_cases) | **PUT** /api/v3/projects/{projectId}/test-cases/update/testcases | Updates multiple test cases
*TestCaseApi* | [**update_test_case**](docs/TestCaseApi.md#update_test_case) | **PUT** /api/v3/projects/{projectId}/test-cases/{testCaseId} | Updates a Test Case
*TestCaseApi* | [**update_test_case_comment**](docs/TestCaseApi.md#update_test_case_comment) | **PUT** /api/v3/projects/{projectId}/test-cases/{idOrKey}/comments/{commentId} | Updates a Comment of a Test Case
*TestCaseApi* | [**update_test_step**](docs/TestCaseApi.md#update_test_step) | **PUT** /api/v3/projects/{projectId}/test-cases/{testCaseId}/test-steps/{stepId} | Update a Test Step
*TestCycleApi* | [**create_cycle**](docs/TestCycleApi.md#create_cycle) | **POST** /api/v3/projects/{projectId}/test-cycles | Create a Test Cycle
*TestCycleApi* | [**delete_cycle**](docs/TestCycleApi.md#delete_cycle) | **DELETE** /api/v3/projects/{projectId}/test-cycles/{testCycleId} | Deletes a Test Cycle
*TestCycleApi* | [**get_test_cycle**](docs/TestCycleApi.md#get_test_cycle) | **GET** /api/v3/projects/{projectId}/test-cycles/{testCycleId} | Gets a Test Cycle
*TestCycleApi* | [**get_test_cycles**](docs/TestCycleApi.md#get_test_cycles) | **GET** /api/v3/projects/{projectId}/test-cycles | Gets multiple Test Cycles
*TestCycleApi* | [**update_cycle**](docs/TestCycleApi.md#update_cycle) | **PUT** /api/v3/projects/{projectId}/test-cycles/{testCycleId} | Updates a Test Cycle
*TestLogApi* | [**get_last_run_log**](docs/TestLogApi.md#get_last_run_log) | **GET** /api/v3/projects/{projectId}/test-runs/{testRunId}/test-logs/last-run | Gets the latest Test Log of a Test Run
*TestLogApi* | [**get_test_log**](docs/TestLogApi.md#get_test_log) | **GET** /api/v3/projects/{projectId}/test-runs/{testRunId}/test-logs/{id} | Gets a Test Log of a Test Run
*TestLogApi* | [**get_test_logs_list**](docs/TestLogApi.md#get_test_logs_list) | **GET** /api/v3/projects/{projectId}/test-runs/{testRunId}/test-logs | Gets all Test Logs of a Test Run
*TestLogApi* | [**modify_automation_log**](docs/TestLogApi.md#modify_automation_log) | **PUT** /api/v3/projects/{projectId}/test-runs/{testRunId}/auto-test-logs/{id} | Modify an Automation Test Log
*TestLogApi* | [**modify_test_log**](docs/TestLogApi.md#modify_test_log) | **PUT** /api/v3/projects/{projectId}/test-runs/{testRunId}/test-logs/{id} | Modify a Manual Test Log
*TestLogApi* | [**submit_automation_log**](docs/TestLogApi.md#submit_automation_log) | **POST** /api/v3/projects/{projectId}/test-runs/{testRunId}/auto-test-logs | Submits an Automation Test Log
*TestLogApi* | [**submit_automation_test_logs**](docs/TestLogApi.md#submit_automation_test_logs) | **POST** /api/v3.1/projects/{projectId}/test-runs/{testRunId}/auto-test-logs | Submits multiple test results
*TestLogApi* | [**submit_automation_test_logs_with_tree_structure**](docs/TestLogApi.md#submit_automation_test_logs_with_tree_structure) | **POST** /api/v3/projects/{projectId}/auto-test-logs | Submits multiple test results and specifies Test Design and Test Execution tree structures
*TestLogApi* | [**submit_test_log**](docs/TestLogApi.md#submit_test_log) | **POST** /api/v3/projects/{projectId}/test-runs/{testRunId}/test-logs | Submits a Manual Test Log
*TestLogApi* | [**track**](docs/TestLogApi.md#track) | **GET** /api/v3/projects/queue-processing/{id} | Gets a Batch Test Log Submission job&#39;s state
*TestRunApi* | [**add_test_run_comment**](docs/TestRunApi.md#add_test_run_comment) | **POST** /api/v3/projects/{projectId}/test-runs/{idOrKey}/comments | Adds a Comment to a Test Run
*TestRunApi* | [**add_test_run_with_parameters**](docs/TestRunApi.md#add_test_run_with_parameters) | **POST** /api/v3/projects/{projectId}/test-runs/assign-parameter-values/manually | Create multiple Test Runs with Parameter values manual
*TestRunApi* | [**add_test_run_with_parameters_dataset**](docs/TestRunApi.md#add_test_run_with_parameters_dataset) | **POST** /api/v3/projects/{projectId}/test-runs/assign-parameter-values/dataset | Create multiple Test Runs with Parameter values from dataset.
*TestRunApi* | [**add_test_run_with_parameters_randomize**](docs/TestRunApi.md#add_test_run_with_parameters_randomize) | **POST** /api/v3/projects/{projectId}/test-runs/assign-parameter-values/randomize | Create multiple Test Runs with Parameter values random from selection combine type.
*TestRunApi* | [**create_test_run**](docs/TestRunApi.md#create_test_run) | **POST** /api/v3/projects/{projectId}/test-runs | Creates a Test Run
*TestRunApi* | [**delete_comment_by_id**](docs/TestRunApi.md#delete_comment_by_id) | **DELETE** /api/v3/projects/{projectId}/test-runs/{idOrKey}/comments/{commentId} | Deletes a Comment of a Test Run
*TestRunApi* | [**delete_test_run_by_id**](docs/TestRunApi.md#delete_test_run_by_id) | **DELETE** /api/v3/projects/{projectId}/test-runs/{testRunId} | Deletes a Test Run
*TestRunApi* | [**get_of**](docs/TestRunApi.md#get_of) | **GET** /api/v3/projects/{projectId}/test-runs | Gets multiple Test Runs
*TestRunApi* | [**get_status_valuable**](docs/TestRunApi.md#get_status_valuable) | **GET** /api/v3/projects/{projectId}/test-runs/execution-statuses | Gets Test Run statuses
*TestRunApi* | [**get_subhierachy**](docs/TestRunApi.md#get_subhierachy) | **GET** /api/v3/projects/{projectId}/test-runs/subhierarchy | Gets a Sub Hierarchy
*TestRunApi* | [**get_test_run_by_id**](docs/TestRunApi.md#get_test_run_by_id) | **GET** /api/v3/projects/{projectId}/test-runs/{testRunId} | Gets a Test Run
*TestRunApi* | [**get_test_run_comment_by_id**](docs/TestRunApi.md#get_test_run_comment_by_id) | **GET** /api/v3/projects/{projectId}/test-runs/{idOrKey}/comments/{commentId} | Gets a Comment from a Test Run
*TestRunApi* | [**get_test_run_comments**](docs/TestRunApi.md#get_test_run_comments) | **GET** /api/v3/projects/{projectId}/test-runs/{idOrKey}/comments | Gets all Comments of a Test Run
*TestRunApi* | [**update_comment_by_id**](docs/TestRunApi.md#update_comment_by_id) | **PUT** /api/v3/projects/{projectId}/test-runs/{idOrKey}/comments/{commentId} | Updates a Comment of a Test Run
*TestRunApi* | [**update_test_run_by_id**](docs/TestRunApi.md#update_test_run_by_id) | **PUT** /api/v3/projects/{projectId}/test-runs/{testRunId} | Updates a Test Run
*TestSuiteApi* | [**create_test_suite**](docs/TestSuiteApi.md#create_test_suite) | **POST** /api/v3/projects/{projectId}/test-suites | Creates a Test Suite
*TestSuiteApi* | [**delete_test_suite_by_id**](docs/TestSuiteApi.md#delete_test_suite_by_id) | **DELETE** /api/v3/projects/{projectId}/test-suites/{testSuiteId} | Deletes a Test Suite
*TestSuiteApi* | [**get_list_test_suite**](docs/TestSuiteApi.md#get_list_test_suite) | **GET** /api/v3/projects/{projectId}/test-suites | Gets multiple Test Suite
*TestSuiteApi* | [**get_test_suite**](docs/TestSuiteApi.md#get_test_suite) | **GET** /api/v3/projects/{projectId}/test-suites/{testSuiteId} | Gets a Test Suite
*TestSuiteApi* | [**update_test_suite**](docs/TestSuiteApi.md#update_test_suite) | **PUT** /api/v3/projects/{projectId}/test-suites/{testSuiteId} | Updates a Test Suite
*ToscaApi* | [**notify_test_event_import**](docs/ToscaApi.md#notify_test_event_import) | **POST** /api/v3/projects/{projectId}/tosca/import/test-event | Import Tosca TestEvent objects
*UserApi* | [**assign_to_project**](docs/UserApi.md#assign_to_project) | **POST** /api/v3/users/{userId}/projects | Assigns a User to a Project
*UserApi* | [**assign_users_to_project**](docs/UserApi.md#assign_users_to_project) | **POST** /api/v3/users/projects | Assigns multiple Users to a Project
*UserApi* | [**create_user**](docs/UserApi.md#create_user) | **POST** /api/v3/users | Invites a User
*UserApi* | [**find_by_user_name_or_email**](docs/UserApi.md#find_by_user_name_or_email) | **GET** /api/v3/users/search | Queries Users by Username
*UserApi* | [**find_users_by_projects_name**](docs/UserApi.md#find_users_by_projects_name) | **GET** /api/v3/search/user | Queries Users by Project Name
*UserApi* | [**get_avatar**](docs/UserApi.md#get_avatar) | **GET** /api/v3/users/{userId}/avatar | Gets a User&#39;s Avatar
*UserApi* | [**get_user_by_id**](docs/UserApi.md#get_user_by_id) | **GET** /api/v3/users/{userId} | Gets a User
*UserApi* | [**reevaluate_token**](docs/UserApi.md#reevaluate_token) | **GET** /api/v3/re-evaluation | Gets current user&#39;s information
*UserApi* | [**remove_association_users_and_projects**](docs/UserApi.md#remove_association_users_and_projects) | **PUT** /api/v3/users/projects | Remove association between users and projects
*UserApi* | [**update_user**](docs/UserApi.md#update_user) | **PUT** /api/v3/users/{userId} | Update user&#39;s information
*UserProfileApi* | [**batch_assign_user_profile_in_client**](docs/UserProfileApi.md#batch_assign_user_profile_in_client) | **POST** /api/v3/user-profiles/batch-assign-users | Assigns multiple Users to a Profile
*UserProfileApi* | [**batch_assign_user_profile_in_project**](docs/UserProfileApi.md#batch_assign_user_profile_in_project) | **POST** /api/v3/user-profiles/{projectId}/batch-assign-users | Assigns multiple Users to a Profile in a Project
*UserProfileApi* | [**get_current**](docs/UserProfileApi.md#get_current) | **GET** /api/v3/admin-profiles/current | Gets current User&#39;s Admin Profile
*UserProfileApi* | [**get_profiles_of_current_user**](docs/UserProfileApi.md#get_profiles_of_current_user) | **GET** /api/v3/user-profiles/current | Gets current User&#39;s Profiles in different Projects
*UserProfileApi* | [**get_user_profiles**](docs/UserProfileApi.md#get_user_profiles) | **GET** /api/v3/user-profiles | Gets available Profiles
*WebhookApi* | [**create_webhook**](docs/WebhookApi.md#create_webhook) | **POST** /api/v3/webhooks | Registers a webhook
*WebhookApi* | [**delete_webhook_by_id**](docs/WebhookApi.md#delete_webhook_by_id) | **DELETE** /api/v3/webhooks/{webhookId} | Deletes a webhook
*WebhookApi* | [**get_all_event_names**](docs/WebhookApi.md#get_all_event_names) | **GET** /api/v3/webhooks/events | Get list of webhook event names
*WebhookApi* | [**get_all_webhooks**](docs/WebhookApi.md#get_all_webhooks) | **GET** /api/v3/webhooks | Gets list of all registered webhooks
*WebhookApi* | [**get_webhook_by_id**](docs/WebhookApi.md#get_webhook_by_id) | **GET** /api/v3/webhooks/{webhookId} | Gets a webhook
*WebhookApi* | [**update_webhook**](docs/WebhookApi.md#update_webhook) | **PUT** /api/v3/webhooks/{webhookId} | Updates a webhook


## Documentation For Models

 - [AdminProfile](docs/AdminProfile.md)
 - [AllowedValueInputResource](docs/AllowedValueInputResource.md)
 - [AllowedValueResource](docs/AllowedValueResource.md)
 - [AllowedValueResponseResource](docs/AllowedValueResponseResource.md)
 - [AppDetail](docs/AppDetail.md)
 - [ApplyTemplateQueryObject](docs/ApplyTemplateQueryObject.md)
 - [ArtifactHistoryResource](docs/ArtifactHistoryResource.md)
 - [ArtifactSearchParams](docs/ArtifactSearchParams.md)
 - [AssignedProject](docs/AssignedProject.md)
 - [AssignedUsersProject](docs/AssignedUsersProject.md)
 - [AttachmentAuthor](docs/AttachmentAuthor.md)
 - [AttachmentResource](docs/AttachmentResource.md)
 - [AuthSystemResponse](docs/AuthSystemResponse.md)
 - [AuthorityVM](docs/AuthorityVM.md)
 - [AutoFillConfigurationVM](docs/AutoFillConfigurationVM.md)
 - [AutomationArtifactSearchParams](docs/AutomationArtifactSearchParams.md)
 - [AutomationFailLinkedDefectResponse](docs/AutomationFailLinkedDefectResponse.md)
 - [AutomationLinkedDefectResponse](docs/AutomationLinkedDefectResponse.md)
 - [AutomationObjectTree](docs/AutomationObjectTree.md)
 - [AutomationRequest](docs/AutomationRequest.md)
 - [AutomationScheduleCreationAPI](docs/AutomationScheduleCreationAPI.md)
 - [AutomationStepLog](docs/AutomationStepLog.md)
 - [AutomationTestLog](docs/AutomationTestLog.md)
 - [AutomationTestLogResource](docs/AutomationTestLogResource.md)
 - [AutomationTestLogResourceResponse](docs/AutomationTestLogResourceResponse.md)
 - [AutomationTestStepLog](docs/AutomationTestStepLog.md)
 - [BuildPermission](docs/BuildPermission.md)
 - [BuildResource](docs/BuildResource.md)
 - [Client](docs/Client.md)
 - [CommentQueryParams](docs/CommentQueryParams.md)
 - [CommentResource](docs/CommentResource.md)
 - [CustomFieldInfo](docs/CustomFieldInfo.md)
 - [CustomFieldTemplate](docs/CustomFieldTemplate.md)
 - [Defect](docs/Defect.md)
 - [DefectComment](docs/DefectComment.md)
 - [DefectFieldMapping](docs/DefectFieldMapping.md)
 - [DefectMapping](docs/DefectMapping.md)
 - [DefectPermission](docs/DefectPermission.md)
 - [DefectResource](docs/DefectResource.md)
 - [DefectTrackingSystem](docs/DefectTrackingSystem.md)
 - [ErrorMessage](docs/ErrorMessage.md)
 - [ExternalPropertyResource](docs/ExternalPropertyResource.md)
 - [FieldInputResource](docs/FieldInputResource.md)
 - [FieldResource](docs/FieldResource.md)
 - [FieldResourceSwagger](docs/FieldResourceSwagger.md)
 - [GetMultipleTestRunListResource](docs/GetMultipleTestRunListResource.md)
 - [GetMultipleTestRunsResource](docs/GetMultipleTestRunsResource.md)
 - [HistoryChange](docs/HistoryChange.md)
 - [HistoryQueryParams](docs/HistoryQueryParams.md)
 - [HistoryResource](docs/HistoryResource.md)
 - [IntegrationAutoFillMappingVM](docs/IntegrationAutoFillMappingVM.md)
 - [IntegrationConnection](docs/IntegrationConnection.md)
 - [IntegrationConnectionVM](docs/IntegrationConnectionVM.md)
 - [IntegrationFieldMapVM](docs/IntegrationFieldMapVM.md)
 - [IntegrationReleaseConfigurationVM](docs/IntegrationReleaseConfigurationVM.md)
 - [IntegrationReleaseConfigurationValues](docs/IntegrationReleaseConfigurationValues.md)
 - [IntegrationReleaseMappingResponse](docs/IntegrationReleaseMappingResponse.md)
 - [LDAPUsersResponse](docs/LDAPUsersResponse.md)
 - [LdapConfigDetailResponse](docs/LdapConfigDetailResponse.md)
 - [LdapUserResource](docs/LdapUserResource.md)
 - [LdapUserVM](docs/LdapUserVM.md)
 - [Link](docs/Link.md)
 - [LinkedArtifact](docs/LinkedArtifact.md)
 - [LinkedArtifactContainer](docs/LinkedArtifactContainer.md)
 - [LinkedDefect](docs/LinkedDefect.md)
 - [LinkedDefectContainer](docs/LinkedDefectContainer.md)
 - [LinkedDefectResource](docs/LinkedDefectResource.md)
 - [LinkedObject](docs/LinkedObject.md)
 - [LoggedUser](docs/LoggedUser.md)
 - [LookUp](docs/LookUp.md)
 - [ManualTestLogResource](docs/ManualTestLogResource.md)
 - [Message](docs/Message.md)
 - [ModulePermission](docs/ModulePermission.md)
 - [ModuleResource](docs/ModuleResource.md)
 - [NewIntegrationConnectionInfo](docs/NewIntegrationConnectionInfo.md)
 - [OAuthResponse](docs/OAuthResponse.md)
 - [OAuthTokenStatusVM](docs/OAuthTokenStatusVM.md)
 - [OutputStream](docs/OutputStream.md)
 - [PagedResource](docs/PagedResource.md)
 - [PagedResourceAttachmentResource](docs/PagedResourceAttachmentResource.md)
 - [PagedResourceCommentResource](docs/PagedResourceCommentResource.md)
 - [ParameterInfo](docs/ParameterInfo.md)
 - [ParameterTestStepResource](docs/ParameterTestStepResource.md)
 - [ParameterVM](docs/ParameterVM.md)
 - [ParameterValueVM](docs/ParameterValueVM.md)
 - [ParameterizationText](docs/ParameterizationText.md)
 - [Profile](docs/Profile.md)
 - [Project](docs/Project.md)
 - [ProjectAdminPermission](docs/ProjectAdminPermission.md)
 - [ProjectModule](docs/ProjectModule.md)
 - [ProjectQueryParams](docs/ProjectQueryParams.md)
 - [ProjectResource](docs/ProjectResource.md)
 - [ProjectSettingPermission](docs/ProjectSettingPermission.md)
 - [ProjectUpdateResource](docs/ProjectUpdateResource.md)
 - [ProjectUsersProfile](docs/ProjectUsersProfile.md)
 - [ProjectWithUserIdsObject](docs/ProjectWithUserIdsObject.md)
 - [PropertyResource](docs/PropertyResource.md)
 - [QueryCommentResource](docs/QueryCommentResource.md)
 - [QueueProcessingResponse](docs/QueueProcessingResponse.md)
 - [QueueProcessingResponseFetchDataVM](docs/QueueProcessingResponseFetchDataVM.md)
 - [QueueProcessingResponseTestRunDataVM](docs/QueueProcessingResponseTestRunDataVM.md)
 - [ReleasePermission](docs/ReleasePermission.md)
 - [ReleaseWithCustomFieldResource](docs/ReleaseWithCustomFieldResource.md)
 - [ReportPermission](docs/ReportPermission.md)
 - [RequirementMapping](docs/RequirementMapping.md)
 - [RequirementPermission](docs/RequirementPermission.md)
 - [RequirementResource](docs/RequirementResource.md)
 - [ResourceSupport](docs/ResourceSupport.md)
 - [ResponseWrapper](docs/ResponseWrapper.md)
 - [SSOSamlConfigDetailResponse](docs/SSOSamlConfigDetailResponse.md)
 - [SchedulePermission](docs/SchedulePermission.md)
 - [SearchUserResource](docs/SearchUserResource.md)
 - [SearchUserResourceExtensionResponse](docs/SearchUserResourceExtensionResponse.md)
 - [SearchUserResponse](docs/SearchUserResponse.md)
 - [SessionManagerPermission](docs/SessionManagerPermission.md)
 - [ShortTestLogResource](docs/ShortTestLogResource.md)
 - [SiteTemplateResponse](docs/SiteTemplateResponse.md)
 - [SiteUsersProfile](docs/SiteUsersProfile.md)
 - [StatusResource](docs/StatusResource.md)
 - [TUAConfigDetailResponse](docs/TUAConfigDetailResponse.md)
 - [TestCaseByTestRunRequirementIdResource](docs/TestCaseByTestRunRequirementIdResource.md)
 - [TestCasePermission](docs/TestCasePermission.md)
 - [TestCaseResource](docs/TestCaseResource.md)
 - [TestCaseResultDefect](docs/TestCaseResultDefect.md)
 - [TestCaseWithCustomFieldResource](docs/TestCaseWithCustomFieldResource.md)
 - [TestCaseWithNoCustomFieldResource](docs/TestCaseWithNoCustomFieldResource.md)
 - [TestCaseWithParameterResource](docs/TestCaseWithParameterResource.md)
 - [TestCycle](docs/TestCycle.md)
 - [TestCyclePermission](docs/TestCyclePermission.md)
 - [TestCycleResource](docs/TestCycleResource.md)
 - [TestLogListResource](docs/TestLogListResource.md)
 - [TestLogResource](docs/TestLogResource.md)
 - [TestParameter](docs/TestParameter.md)
 - [TestRunByRequirementIdListResource](docs/TestRunByRequirementIdListResource.md)
 - [TestRunByRequirementIdResource](docs/TestRunByRequirementIdResource.md)
 - [TestRunListResource](docs/TestRunListResource.md)
 - [TestRunPermission](docs/TestRunPermission.md)
 - [TestRunWithCustomFieldResource](docs/TestRunWithCustomFieldResource.md)
 - [TestRunWithParameterCreateByDatasetResource](docs/TestRunWithParameterCreateByDatasetResource.md)
 - [TestRunWithParameterCreateManualResource](docs/TestRunWithParameterCreateManualResource.md)
 - [TestRunWithParameterCreateRandomResource](docs/TestRunWithParameterCreateRandomResource.md)
 - [TestStepInformationVM](docs/TestStepInformationVM.md)
 - [TestStepLogResource](docs/TestStepLogResource.md)
 - [TestStepResource](docs/TestStepResource.md)
 - [TestStepWithNoCustomFieldInformationVM](docs/TestStepWithNoCustomFieldInformationVM.md)
 - [TestStepWithNoCustomFieldsResource](docs/TestStepWithNoCustomFieldsResource.md)
 - [TestStepWithParameterResource](docs/TestStepWithParameterResource.md)
 - [TestSuite](docs/TestSuite.md)
 - [TestSuitePermission](docs/TestSuitePermission.md)
 - [TestSuiteWithCustomFieldResource](docs/TestSuiteWithCustomFieldResource.md)
 - [TokenSecretVerifierHolder](docs/TokenSecretVerifierHolder.md)
 - [ToscaExecutionEntryResource](docs/ToscaExecutionEntryResource.md)
 - [ToscaTestCaseResource](docs/ToscaTestCaseResource.md)
 - [ToscaTestCycleResource](docs/ToscaTestCycleResource.md)
 - [TraceabilityRequirement](docs/TraceabilityRequirement.md)
 - [UserGroupResource](docs/UserGroupResource.md)
 - [UserInfoVM](docs/UserInfoVM.md)
 - [UserProfile](docs/UserProfile.md)
 - [UserProfileResponse](docs/UserProfileResponse.md)
 - [UserResource](docs/UserResource.md)
 - [UserResourceExtension](docs/UserResourceExtension.md)
 - [UserUpdateResource](docs/UserUpdateResource.md)
 - [WebhookRequest](docs/WebhookRequest.md)
 - [WebhookVM](docs/WebhookVM.md)


## Documentation For Authorization


## Authorization

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author



